function [B, detJ] = BQ8_2D( iG, P, MSH )

    %Q8 : macierz B
            
    N = NQ8( iG );
    GPxy = N * P;
    
    %wspolrzedne pkt. Gaussa
    GP = GaussQ8( iG );
    ksi = GP.ksi;
    eta = GP.eta;

    %pochodne dN/dL
    dNL(1,1) = 0.25 .* ( 2 .* ksi + eta - 2 .* ksi .* eta - eta .* eta );
    dNL(1,2) = 0.5 .* ( eta .* eta - 1 ) ;
    dNL(1,3) = 0.25 .* ( 2 .* ksi - eta + 2 .* ksi .* eta - eta .* eta );
    dNL(1,4) = -1 .* ( ksi + ksi .* eta );
    dNL(1,5) = 0.25 .* ( 2 .* ksi + eta + 2 .* ksi .* eta + eta .* eta );
    dNL(1,6) = 0.5 .* ( 1 - eta .* eta );
    dNL(1,7) = 0.25 .* ( 2 .* ksi - eta - 2 .* ksi .* eta + eta .* eta );
    dNL(1,8) = ksi .* ( eta - 1 );
    dNL(2,1) = 0.25 .* ( 2 .* eta + ksi - 2 .* ksi .* eta - ksi .* ksi );
    dNL(2,2) = eta .* ksi - eta;
    dNL(2,3) = 0.25 .* ( 2 .* eta - ksi - 2 .* ksi .* eta + ksi .* ksi );
    dNL(2,4) = 0.5 .* ( 1 - ksi .* ksi );
    dNL(2,5) = 0.25 .* ( 2 .* eta + ksi + 2 .* ksi .* eta + ksi .* ksi );
    dNL(2,6) = -1 .* eta .* ( 1 + ksi );
    dNL(2,7) = 0.25 .* ( 2 .* eta - ksi + 2 .* ksi .* eta - ksi .* ksi );
    dNL(2,8) = 0.5 .* ( ksi .* ksi - 1 );

    %macierz Jacobiego = dN/dL * P(x,y)
    J = dNL * P;			
    detJ = det(J);
    invJ = inv(J);

    %macierz B - plaski stan odksztalcenia
    dNX = invJ * dNL;
    B = zeros(4,16);
        
    B(1,1) = dNX(1,1);
    B(1,3) = dNX(1,2);
    B(1,5) = dNX(1,3);
    B(1,7) = dNX(1,4);
    B(1,9) = dNX(1,5);
    B(1,11) = dNX(1,6);
    B(1,13) = dNX(1,7);
    B(1,15) = dNX(1,8);

    B(2,2) = dNX(2,1);
    B(2,4) = dNX(2,2);
    B(2,6) = dNX(2,3);
    B(2,8) = dNX(2,4);
    B(2,10) = dNX(2,5);
    B(2,12) = dNX(2,6);
    B(2,14) = dNX(2,7);
    B(2,16) = dNX(2,8);

    B(3,1) = B(2,2);
    B(3,2) = B(1,1);
    B(3,3) = B(2,4);
    B(3,4) = B(1,3);
    B(3,5) = B(2,6);
    B(3,6) = B(1,5);
    B(3,7) = B(2,8);
    B(3,8) = B(1,7);
    B(3,9) = B(2,10);
    B(3,10) = B(1,9);
    B(3,11) = B(2,12);
    B(3,12) = B(1,11);
    B(3,13) = B(2,14);
    B(3,14) = B(1,13);
    B(3,15) = B(2,16);
    B(3,16) = B(1,15);
        
   
