function [Material, Calculation, Mesh] = DataQ8()
    %UWAGA! Tutaj wszystkie numeracje od 1! MATLAB!

    %PARAMETRY MATERIALOWE

    %modul Younga [kPa]
    Material.E = 1E4;

    %wsp. Poissona
    Material.ni = 0.3;

    %modul odksztalcenia objetosciowego wody [kPa]
    %Material.Ke = 2.2E6;
    Material.Ke = 0;

    %katy Fi: poczatkowy, pikowy i rezydualny [deg]
    Material.Fi = [20 20 20];

    %spojnosci: poczatkowa, pikowa i rezydualna [kPa]
    Material.c = [10 10 10];

    %progi zmiany Fi
    Material.Edpf = [0.01 0.06 0.12];

    %progi zmiany c
    Material.Edpc = [0.01 0.06 0.12];

    %katy Psi: poczatkowy, pikowy i rezydualny [deg]
    Material.Psi = [0 -1 1];

    %progi zmiany Psi
    Material.Edpp = [0.01 0.06 0.12];
    
    %PARAMETRY OBLICZENIOWE

    %liczba inkrementow 
    Calculation.Incr = 100;

    %tolerancja bledu dla iteracji
    Calculation.IterTol = 1E-5;

    %maksymalna liczba iteracji
    Calculation.IterMax = 50;

    %cisnienie normalne [kPa]
    Calculation.NormPres = -150.0;

    %wspolczynnik K0
    Calculation.K0 = 1 - sin(Material.Fi(1,1).*pi./180);

    %wyjsciowe cisnienie w porach [kPa]
    Calculation.PorePres = 0;

    %SIATKA

    %wysokosc probki [m]
    h = 0.05;
    Mesh.h = h;

    %szerokosc probki [m]
    w = 0.06;
    Mesh.w = w;

    %dlugosc probki [m]
    l = 0.06;
    Mesh.l = l;

    %wspolrzedne wezlow
    Mesh.Nodes = [0 0; 0 h/2; 0 h; w/2 h; w h;  w h/2;  w 0; w/2 0];

    %definicja elementu: wezly
    Mesh.Elem.nod = [1 2 3 4 5 6 7 8];

    %przemieszczenie na 1 inkrement [m]
    Mesh.Disps = w./Calculation.Incr./10.0;
