function dee = deemat(e,v,ih)
%
% This subroutine returns the elastic dee matrix for ih=3 (plane strain),
% ih=4 (axisymmetry or plane strain elastoplasticity) or ih=6
% (three dimensions).
%
zero=0;
pt5=0.5;
one=1;
two=2;
dee=zeros(ih,ih);  
v1=one-v;
c=e/((one+v)*(one-two*v));
if ih==3
    dee(1,1)=v1*c;
    dee(2,2)=v1*c;
    dee(1,2)=v*c;
    dee(2,1)=v*c;
    dee(3,3)=pt5*c*(one-two*v);
end
if ih==4
    dee(1,1)=v1*c;
    dee(2,2)=v1*c;
    dee(4,4)=v1*c;
    dee(3,3)=pt5*c*(one-two*v); 
    dee(1,2)=v*c;
    dee(2,1)=v*c;
    dee(1,4)=v*c;
    dee(4,1)=v*c;
    dee(2,4)=v*c;
    dee(4,2)=v*c;
end
if ih==6
    v2=v/(one-v);
    vv=(one-two*v)/(one-v)*pt5;
    dee(1,1)=one;
    dee(2,2)=one;
    dee(3,3)=one;
    dee(4,4)=vv;
    dee(5,5)=vv;
    dee(6,6)=vv;
    dee(1,2)=v2;
    dee(2,1)=v2;
    dee(1,3)=v2;
    dee(3,1)=v2;
    dee(2,3)=v2;
    dee(3,2)=v2;
    dee=dee*e/(two*(one+v)*vv);
end