function [] = testQ8()

%nazwa pliku z danymi dowiadczalnymi
dataexp = 'I01_150kPa.txt';
%nazwa eksperymentu
nameexp = 'I (r=0.1mm/min, \sigma_n=150kPa)';

%inicjalizacja danych
[Mat Cal Msh] = DataQ8;

%tu dostosowywujemy parametry modelu
Mat.Fi = [1 3 4];
Mat.c = [3 5 10];
Mat.Psi = [0 0 0];
Mat.Edpf = [0.01 0.05 0.10];
Mat.Edpc = [0.01 0.05 0.10];
Mat.Edpp = [0.01 0.05 0.10];

%obliczenia
Cal.K0 = 1 - sin(Mat.Fi(1,1).*pi./180);
[Disp, Stress, Edp] = shearQ8(Mat, Cal, Msh, 0);

%wykresy
subplot(2,1,1);
plot(Disp(1,:)./0.0006, -Stress(1,:), '.-b', Disp(1,:)./0.0006, -Stress(2,:), '.-k', Disp(1,:)./0.0006, -Stress(4,:), '.-m');
legend('\sigma_x','\sigma_y','\sigma_z');
legend('Location','East');
xlabel('\epsilon_x [%]','FontWeight','bold','FontSize',12);
ylabel('\sigma [kPa]','FontWeight','bold','FontSize',12);
title(nameexp,'FontName','Arial CE','FontWeight','bold','FontSize',14);

subplot(2,1,2);
plot(Disp(1,:)./0.0006, Stress(3,:), '.-r');
xlabel('\epsilon_x [%]','FontWeight','bold','FontSize',12);
ylabel('\tau_x_y [kPa]','FontWeight','bold','FontSize',12);
hold on;

%tu wczytujemy dane eksperymentalne
dane = read_data(dataexp);

%i umieszczamy na wykresie
plot(dane(:,1), dane(:,2), '-b');
legend('obliczenia','eksperyment');
legend('Location','East');
